func up_stepping( delta:float ):
	var space_state : PhysicsDirectSpaceState = get_world().direct_space_state as PhysicsDirectSpaceState
	var param := PhysicsShapeQueryParameters.new()
	var motion :Vector3 = velocity * delta
	var reminder :Vector3
	var extra_margin := 0.0
	var current_shape = col_stand if !col_stand.disabled else col_crouch
	
	param.collision_mask = self.collision_mask
	param.set_shape( current_shape.shape )
	param.transform = current_shape.global_transform
	param.margin = current_shape.shape.margin
	param.exclude = [ self ]
	

	var trace := space_state.cast_motion( param, motion )

	if not (trace[0] == 1.0 and trace[1] == 1.0): # frontal collision
		
		var front_normal = space_state.get_rest_info(param).get("normal").y if space_state.get_rest_info(param).get("normal") != null else 0
		param.transform.origin += motion * trace[1]     # I think if reminder become too small, trace step down will miss the collision later. With this, change shape will collide with step but cast_motion ignore it based on document, no worries
		reminder = motion - (motion * trace[1])
		motion = Vector3.UP * (step_height + extra_margin)
		trace = space_state.cast_motion( param, motion )

		if trace[0] == 1.0 and trace[1] == 1.0: # no ceiling collision
			param.transform.origin += motion
			trace = space_state.cast_motion( param, reminder )

			if trace[0] > 0.0: # if there's space forward..
				param.transform.origin += reminder * trace[1]

				# that code_block could be replaced by a recursive function
				if not (trace[0] == 1.0 and trace[1] == 1.0):     # frontal collision with next-step → cast_up
					motion = Vector3.UP * (step_height + extra_margin)
					trace = space_state.cast_motion( param, motion )

					if trace[0] == 1.0 and trace[1] == 1.0: # no ceiling collision → cast_forward
						param.transform.origin += motion
						reminder -= reminder * trace[1]
						trace = space_state.cast_motion( param, reminder )
						if trace[0] == 1.0 and trace[1] == 1.0:
							param.transform.origin += reminder
				motion = Vector3.DOWN * (step_height + extra_margin)
				trace = space_state.cast_motion( param, motion )
				if not (trace[0] == 1.0 and trace[1] == 1.0): # collision with step-surface
					param.transform.origin += motion * trace[1]
					var collision     := space_state.get_rest_info(param)
					if not collision.empty():
						if collision.get("normal").y < 0.999 and stepify(front_normal, 0.01) == stepify(get_floor_normal().y, 0.01) and stepify(collision.get("normal").y, 0.01) == stepify(get_floor_normal().y, 0.01):
							return
						if not self.global_transform.origin.distance_to(param.transform.origin) > step_height:
							self.transform.origin = param.transform.origin
							self.transform.origin.y -= current_shape.transform.origin.y - 0.5
							# using Zylann's plugin to visualize shape-casting
							debug_pos = param.transform.origin

